/**
 * ISC License
 *
 * Copyright (c) 2018, Aleck Greenham
 *
 * Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('prop-types'), require('react'), require('lodash.isequal'), require('create-react-class'), require('react-dom'), require('lodash.isboolean'), require('lodash.isobject')) :
  typeof define === 'function' && define.amd ? define(['exports', 'prop-types', 'react', 'lodash.isequal', 'create-react-class', 'react-dom', 'lodash.isboolean', 'lodash.isobject'], factory) :
  (factory((global.ReactHotkeys = {}),global.PropTypes,global.React,global.isEqual,global.createReactClass,global.ReactDOM,global.isBool,global.isObject));
}(this, (function (exports,PropTypes,React,isEqual,createReactClass,ReactDOM,isBool,isObject) { 'use strict';

  PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;
  React = React && React.hasOwnProperty('default') ? React['default'] : React;
  isEqual = isEqual && isEqual.hasOwnProperty('default') ? isEqual['default'] : isEqual;
  createReactClass = createReactClass && createReactClass.hasOwnProperty('default') ? createReactClass['default'] : createReactClass;
  ReactDOM = ReactDOM && ReactDOM.hasOwnProperty('default') ? ReactDOM['default'] : ReactDOM;
  isBool = isBool && isBool.hasOwnProperty('default') ? isBool['default'] : isBool;
  isObject = isObject && isObject.hasOwnProperty('default') ? isObject['default'] : isObject;

  var classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  var createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var inherits = function (subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  };

  var objectWithoutProperties = function (obj, keys) {
    var target = {};

    for (var i in obj) {
      if (keys.indexOf(i) >= 0) continue;
      if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
      target[i] = obj[i];
    }

    return target;
  };

  var possibleConstructorReturn = function (self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  };

  var FocusTrap = function (_React$Component) {
    inherits(FocusTrap, _React$Component);

    function FocusTrap() {
      classCallCheck(this, FocusTrap);
      return possibleConstructorReturn(this, (FocusTrap.__proto__ || Object.getPrototypeOf(FocusTrap)).apply(this, arguments));
    }

    createClass(FocusTrap, [{
      key: 'render',
      value: function render() {
        var _props = this.props,
            Component = _props.component,
            children = _props.children,
            props = objectWithoutProperties(_props, ['component', 'children']);


        return React.createElement(
          Component,
          _extends({ tabIndex: '-1' }, props),
          children
        );
      }
    }]);
    return FocusTrap;
  }(React.Component);

  FocusTrap.propTypes = {
    onFocus: PropTypes.func,
    onBlur: PropTypes.func,
    component: PropTypes.any,
    children: PropTypes.node
  };
  FocusTrap.defaultProps = {
    component: 'div'
  };

  function HotKeyMapMixin() {
    var hotKeyMap = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};


    return {

      contextTypes: {
        hotKeyMap: PropTypes.object
      },

      childContextTypes: {
        hotKeyMap: PropTypes.object
      },

      getChildContext: function getChildContext() {
        return {
          hotKeyMap: this.__hotKeyMap__
        };
      },
      componentWillMount: function componentWillMount() {
        this.updateMap();
      },
      updateMap: function updateMap() {
        var newMap = this.buildMap();

        if (!isEqual(newMap, this.__hotKeyMap__)) {
          this.__hotKeyMap__ = newMap;
          return true;
        }

        return false;
      },
      buildMap: function buildMap() {
        var parentMap = this.context.hotKeyMap || {};
        var thisMap = this.props.keyMap || {};

        return _extends({}, parentMap, hotKeyMap, thisMap);
      },
      getMap: function getMap() {
        return this.__hotKeyMap__;
      }
    };
  }

  function getSequencesFromMap(hotKeyMap, hotKeyName) {
    var sequences = hotKeyMap[hotKeyName];

    // If no sequence is found with this name we assume
    // the user is passing a hard-coded sequence as a key
    if (!sequences) {
      return [hotKeyName];
    }

    if (Array.isArray(sequences)) {
      return sequences;
    }

    return [sequences];
  }

  var HotKeys = createReactClass({
    displayName: 'HotKeys',
    mixins: [HotKeyMapMixin()],

    propTypes: {
      children: PropTypes.node,
      onFocus: PropTypes.func,
      onBlur: PropTypes.func,
      keyMap: PropTypes.object,
      handlers: PropTypes.object,
      focused: PropTypes.bool, // externally controlled focus
      attach: PropTypes.any // dom element to listen for key events
    },

    contextTypes: {
      hotKeyParent: PropTypes.any
    },

    childContextTypes: {
      hotKeyParent: PropTypes.any
    },

    getChildContext: function getChildContext() {
      return {
        hotKeyParent: this
      };
    },
    componentDidMount: function componentDidMount() {
      // import is here to support React's server rendering as Mousetrap immediately
      // calls itself with window and it fails in Node environment
      var Mousetrap = require('mousetrap');
      // Not optimal - imagine hundreds of this component. We need a top level
      // delegation point for mousetrap
      this.__mousetrap__ = new Mousetrap(this.props.attach || ReactDOM.findDOMNode(this));

      this.updateHotKeys(true);
    },
    componentDidUpdate: function componentDidUpdate(prevProps) {
      this.updateHotKeys(false, prevProps);
    },
    componentWillUnmount: function componentWillUnmount() {
      if (this.context.hotKeyParent) {
        this.context.hotKeyParent.childHandledSequence(null);
      }

      if (this.__mousetrap__) {
        this.__mousetrap__.reset();
      }
    },
    updateHotKeys: function updateHotKeys() {
      var _this = this;

      var force = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var prevProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var _props$handlers = this.props.handlers,
          handlers = _props$handlers === undefined ? {} : _props$handlers;
      var _prevProps$handlers = prevProps.handlers,
          prevHandlers = _prevProps$handlers === undefined ? handlers : _prevProps$handlers;

      // Ensure map is up-to-date to begin with
      // We will only bother continuing if the map was actually updated

      if (!force && !this.updateMap() && isEqual(handlers, prevHandlers)) {
        return;
      }

      var hotKeyMap = this.getMap();
      var sequenceHandlers = [];
      var mousetrap = this.__mousetrap__;

      // Group all our handlers by sequence
      Object.keys(handlers).forEach(function (hotKey) {
        var handler = handlers[hotKey];

        var handlerSequences = getSequencesFromMap(hotKeyMap, hotKey);

        // Could be optimized as every handler will get called across every bound
        // component - imagine making a node a focus point and then having hundreds!
        handlerSequences.forEach(function (sequence) {
          var action = void 0;

          var callback = function callback(event, sequence) {
            // Check we are actually in focus and that a child hasn't already handled this sequence
            var isFocused = isBool(_this.props.focused) ? _this.props.focused : _this.__isFocused__;

            if (isFocused && sequence !== _this.__lastChildSequence__) {
              if (_this.context.hotKeyParent) {
                _this.context.hotKeyParent.childHandledSequence(sequence);
              }

              return handler(event, sequence);
            }
          };

          if (isObject(sequence)) {
            action = sequence.action;
            sequence = sequence.sequence;
          }

          sequenceHandlers.push({ callback: callback, action: action, sequence: sequence });
        });
      });

      // Hard reset our handlers (probably could be more efficient)
      mousetrap.reset();
      sequenceHandlers.forEach(function (handler) {
        return mousetrap.bind(handler.sequence, handler.callback, handler.action);
      });
    },
    childHandledSequence: function childHandledSequence() {
      var sequence = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      this.__lastChildSequence__ = sequence;

      // Traverse up any hot key parents so everyone is aware a child has handled a certain sequence
      if (this.context.hotKeyParent) {
        this.context.hotKeyParent.childHandledSequence(sequence);
      }
    },
    onFocus: function onFocus() {
      this.__isFocused__ = true;

      if (this.props.onFocus) {
        var _props;

        (_props = this.props).onFocus.apply(_props, arguments);
      }
    },
    onBlur: function onBlur() {
      this.__isFocused__ = false;

      if (this.props.onBlur) {
        var _props2;

        (_props2 = this.props).onBlur.apply(_props2, arguments);
      }
      if (this.context.hotKeyParent) {
        this.context.hotKeyParent.childHandledSequence(null);
      }
    },
    render: function render() {
      var _props3 = this.props,
          children = _props3.children,
          keyMap = _props3.keyMap,
          handlers = _props3.handlers,
          focused = _props3.focused,
          attach = _props3.attach,
          props = objectWithoutProperties(_props3, ['children', 'keyMap', 'handlers', 'focused', 'attach']);


      return React.createElement(
        FocusTrap,
        _extends({}, props, { onFocus: this.onFocus, onBlur: this.onBlur }),
        children
      );
    }
  });

  exports.HotKeys = HotKeys;
  exports.FocusTrap = FocusTrap;
  exports.HotKeyMapMixin = HotKeyMapMixin;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
